<!-- LANGUAGE SELECTOR -->
<template>
  <div>
    <div class=" iconWrap d-flex flex-column flex-lg-row align-items-center header-top-button position-relative"
      data-toggle="modal" data-target="#languageSelectorModal" data-backdrop="false" focus="false" id="langWrapperCenter"
      ref="langWrapperCenter">
      <language-selection-icon :locale="locale" />
      <div class="mobile-header-top-text">{{ languages[locale] }}</div>

    </div>
    <!-- Language Selector Modal -->
    <div class="modal boxShdw" id="languageSelectorModal" tabindex="-1" role="dialog"
      aria-labelledby="Language Selector Modal" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-body ">
            <div class="d-flex justify-content-end">

            </div>
            <div class="d-flex align-items-center selectHead">

              <div>{{ $t('message.header.languageSelection.selectLanguage') }}</div>
              <div class="close-button d-flex align-items-center justify-content-end" data-dismiss="modal"
                aria-label="Close">

                <svg xmlns="http://www.w3.org/2000/svg" height="20px" fill="#0e47cb" viewBox="0 0 512 512">
                  <path
                    d="M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm121.6 313.1c4.7 4.7 4.7 12.3 0 17L338 377.6c-4.7 4.7-12.3 4.7-17 0L256 312l-65.1 65.6c-4.7 4.7-12.3 4.7-17 0L134.4 338c-4.7-4.7-4.7-12.3 0-17l65.6-65-65.6-65.1c-4.7-4.7-4.7-12.3 0-17l39.6-39.6c4.7-4.7 12.3-4.7 17 0l65 65.7 65.1-65.6c4.7-4.7 12.3-4.7 17 0l39.6 39.6c4.7 4.7 4.7 12.3 0 17L312 256l65.6 65.1z" />
                </svg>
              </div>
            </div>
            <div>
              <div class="d-flex">
                <div class=" d-flex px-3 flex-wrap justify-content-between w-100">
                  <div class=" mb-3 mt-1 font-weight-bold w-100 headerLangSelect">{{
                    $t('message.header.languageSelection.officialLanguages') }}
                  </div>
                  <language-box v-for="lang in Object.keys(languages)" :key="lang" :countryCode="lang"
                    :language="languages[lang]" :selectedLanguage="languages[locale]" class="mb-2" />
                </div>
                <!-- <div class="otherLanguages px-3 d-flex flex-wrap justify-content-between w-50">
                  <div class=" mb-3 mt-1 font-weight-bold w-100 headerLangSelect">Other languages:
                  </div>
                </div> -->
              </div>
            </div>

            <div class="mb-4" />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import LanguageBox from './LanguageBox.vue';
import LanguageSelectionIcon from './LanguageSelectionIcon.vue';


export default {
  name: 'language-selector',
  components: {
    LanguageBox,
    LanguageSelectionIcon,


  },
  props: {
    initialLocale: {
      type: String,
      default: 'en',
    },
    fallbackLocale: {
      type: String,
      default: 'en',
    },
  },
  data() {
    return {
      open: true,
      languages: {
        bg: 'Български',
        cs: 'čeština',
        da: 'dansk',
        de: 'Deutsch',
        el: 'Ελληνικά',
        en: 'English',
        es: 'español',
        et: 'eesti',
        fr: 'français',
        ga: 'Gaeilge',
        hr: 'Hrvatski',
        hu: 'Magyar',
        it: 'italiano',
        lt: 'lietuvių',
        lv: 'latviešu',
        mt: 'Malti',
        nl: 'Nederlands',
        pl: 'polski',
        pt: 'português',
        ro: 'română',
        sk: 'slovenčina',
        sl: 'slovenščina',
        fi: 'suomi',
        sv: 'svenska',
      },
    };
  },
  computed: {
    locale: {
      get() {
        return this.getLocale();
      },
      set(locale) {
        this.$i18n.locale = locale;
        // Wait until router is ready before changing it
        // Necessary when routing to lazy-loaded components
        // Fixes https://gitlab.fokus.fraunhofer.de/viaduct/piveau-ui/piveau-ui/issues/210
        this.$router.isReady().then(() => {
          if (locale !== this.$route.query.locale) {
            this.$router.push({ query: { ...this.$route.query, locale } });
          }
        });
      },
    },
    offset: {
      get() {
       const languageBoxHeader = this.$refs.langWrapperCenter;
        if (languageBoxHeader) {
          return (languageBoxHeader.offsetLeft + languageBoxHeader.offsetWidth / 2 + 10) + "%";
        }
        return undefined;
      },
      set() {
      }


    }
  },
  methods: {
    initLocale() {
      this.$router.isReady().then(() => {
        this.locale = this.getLocale();
      });
    },
    getLocale() {
      if (this.$route.query.locale) return this.$route.query.locale;
      // eslint-disable-next-line max-len
      if (this.languages[navigator.language.substring(0, 2)]) return navigator.language.substring(0, 2);
      if (this.$env.languages.locale) return this.$env.languages.locale;
      return this.$env.languages.fallbackLocale;
    },
  },
  beforeUpdate() {
    this.initLocale();
  },
  created() {
    this.initLocale();
  },
  mounted() {


  },
};
</script>

<style lang="scss" scoped>


#languageSelectorModal {
  overflow: unset;
}

#languageSelectorModal::before {
  background-color: #fff;
  box-shadow: 0 0 6px rgba(9, 49, 142, .2);
  -webkit-clip-path: polygon(-6px -6px, calc(100% + 6px) -6px, calc(100% + 6px) calc(100% + 6px));
  clip-path: polygon(-6px -6px, calc(100% + 6px) -6px, calc(100% + 6px) calc(100% + 6px));
  content: "";
  height: 1rem;
  margin-left: -0.5rem;
  position: absolute;
  top: 0;
  transform: translateY(-50%) rotate(-45deg);
  width: 1rem;
  left: v-bind('offset');
}

.text-black {
  color: black;
}

.boxShdw {
  box-shadow: 0 0 6px rgba(9, 49, 142, .2);

}

.otherLanguages {
  border-left: 2px solid #cfdaf5;
}

.selectHead {
  padding: 0 1rem;
  margin-bottom: 1rem;
  justify-content: space-between;
  border-bottom: 1px solid #e7edfa;
  font: normal normal 400 1.125rem/1.75rem arial, sans-serif;
}

.center {
  margin: 0;
  position: absolute;
  top: 50%;
  left: 50%;
  -ms-transform: translate(-50%, -50%);
  transform: translate(-50%, -50%);
}

.modal-body {
  padding: 0;
  padding-top: 0.5rem !important;

  max-width: 30%;
}

.container {
  width: 66%;
  margin: 0 auto;
}

.modal-content {
  border: none !important;
  display: flex;
  align-items: center;
}

@media only screen and (max-width: 1000px) {
  .container {
    width: 92%;
  }
}



.language-selector {
  width: 150px;
  padding-right: 56px !important;
}

.modal {
  padding: 0px !important;
  position: absolute;
  top: 3.5rem;
  left: -300%;
  z-index: 1050;
  display: none;
  width: 35rem;
  height: auto;
  overflow: hidden;
  outline: 0;
  border-radius: 5px;

  .modal-body {
    max-width: 100%;
  }
}

.modal-dialog {
  max-width: 100% !important;
  margin: 0;
}

.modal-content {


  background-color: white;
  border-radius: 0 !important;
}

.close-button {
  font-size: 1rem;
  margin-bottom: 0.5rem;
  color: $primary;
  cursor: pointer;
  padding: .75rem 1rem;
  border-radius: 5px;

  .center {
    font-size: 2rem;
    font-weight: 300;
  }

  &:hover {

    box-shadow: 0 2px 4px rgba(9, 49, 142, .08), 0 0 10px rgba(9, 49, 142, .04), 0 4px 5px rgba(9, 49, 142, .04), 0 -4px 4px rgba(9, 49, 142, .04);
  }
}

.close-circle {
  border: 1px solid white;
  padding: 5px;
  border-radius: 100% !important;
  width: 20px;
  height: 20px;
  font-family: sans-serif !important;
}

@media only screen and (max-width: $laptop) {
  #languageSelectorModal {
    overflow: scroll;
  }

  .modal {
    padding: 0px;

    top: 4rem;
    left: -82vw;
    z-index: 1050;
    display: none;
    width: 90vw;
    height: 100vh;

    outline: 0;
    border-radius: 5px;
  }
}

@media only screen and (max-width: $mobile) {
  .modal {
    padding: 0px;

    top: 4rem;
    left: -81vw;
    z-index: 1050;
    display: none;
    width: 100vw;
    height: 100vh;
    outline: 0;
    border-radius: 5px;
  }
}
</style>
